/*
 * Author: Clemens Valens (www.polyvalens.com)
 * Book: Mastering Microcontrollers Helped By Arduino
 * WWW: www.elektor.com/arduinobook
 * ISBN: 978-1-907920-23-3
 *
 * Arduino driver for HP03 pressure sensor.
 */

#ifndef __HP03_H__
#define __HP03_H__

#include "Arduino.h"


class HP03
{
public:
  HP03(void) {}
  HP03(uint8_t mclk, uint8_t xclr) { begin(mclk,xclr); }

  void begin(uint8_t mclk, uint8_t xclr);
  void update(void);

  float get_temperature(void) { return _temperature/10.0; }
  float get_pressure(void) { return _pressure/10.0; } 

  uint8_t read_eeprom(void);

  void test(void);

private:
  uint32_t _pressure;
  uint32_t _temperature;
  int32_t _C[8];
  uint8_t _AA;
  uint8_t _BB;
  uint8_t _CC;
  uint8_t _DD;
  uint8_t _mclk;
  uint8_t _xclr;

  uint16_t read_value(uint8_t sensor);
  void read(void);
  void calculate(void);
};


#endif /* __HP03_H__ */


